// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/releaselicense"
)

// ReleaseLicenseDelete is the builder for deleting a ReleaseLicense entity.
type ReleaseLicenseDelete struct {
	config
	hooks    []Hook
	mutation *ReleaseLicenseMutation
}

// Where appends a list predicates to the ReleaseLicenseDelete builder.
func (rld *ReleaseLicenseDelete) Where(ps ...predicate.ReleaseLicense) *ReleaseLicenseDelete {
	rld.mutation.Where(ps...)
	return rld
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (rld *ReleaseLicenseDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(rld.hooks) == 0 {
		affected, err = rld.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ReleaseLicenseMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			rld.mutation = mutation
			affected, err = rld.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(rld.hooks) - 1; i >= 0; i-- {
			if rld.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = rld.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, rld.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (rld *ReleaseLicenseDelete) ExecX(ctx context.Context) int {
	n, err := rld.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (rld *ReleaseLicenseDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: releaselicense.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releaselicense.FieldID,
			},
		},
	}
	if ps := rld.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, rld.driver, _spec)
}

// ReleaseLicenseDeleteOne is the builder for deleting a single ReleaseLicense entity.
type ReleaseLicenseDeleteOne struct {
	rld *ReleaseLicenseDelete
}

// Exec executes the deletion query.
func (rldo *ReleaseLicenseDeleteOne) Exec(ctx context.Context) error {
	n, err := rldo.rld.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{releaselicense.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (rldo *ReleaseLicenseDeleteOne) ExecX(ctx context.Context) {
	rldo.rld.ExecX(ctx)
}
